Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/namelist_medusa_ref
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/namelist_medusa_ref	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/namelist_medusa_ref	(revision 10149)
@@ -305,4 +305,7 @@
       scl_chl    = 1.0      !! (IF key_oasis) scaling the exported to UM chlorophyll field
 !!
+!! FOAM                         !! DAF
+      ln_foam_medusa = .false.  !! Calculate and save diagnostics for data assimilation
+!!
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
@@ -319,4 +322,5 @@
 !!                    = (119 / 106) = 1.1226 mol O2 / mol C
 !!       xo2min    :  oxygen minimum concentration
+!!       xobs_xco2a:  observed atmospheric xCO2 (not used if <= 0)
 !
 &natroam
@@ -326,4 +330,5 @@
    xthetarem = 1.1226
    xo2min    = 4.0
+   xobs_xco2a= -999.0
 /
 !'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/namelist_ref
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 10149)
@@ -1287,20 +1287,43 @@
 &nam_asminc   !   assimilation increments                               ('key_asminc')
 !-----------------------------------------------------------------------
-    ln_bkgwri = .false.    !  Logical switch for writing out background state
-    ln_trainc = .false.    !  Logical switch for applying tracer increments
-    ln_dyninc = .false.    !  Logical switch for applying velocity increments
-    ln_sshinc = .false.    !  Logical switch for applying SSH increments
-    ln_asmdin = .false.    !  Logical switch for Direct Initialization (DI)
-    ln_asmiau = .false.    !  Logical switch for Incremental Analysis Updating (IAU)
-    ln_seaiceinc = .false. !  Logical switch for applying sea ice increments
+    ln_bkgwri      = .false. !  Logical switch for writing out background state
+    ln_balwri      = .false. !  Logical switch for writing out balancing increments
+    ln_trainc      = .false. !  Logical switch for applying tracer increments
+    ln_dyninc      = .false. !  Logical switch for applying velocity increments
+    ln_sshinc      = .false. !  Logical switch for applying SSH increments
+    ln_asmdin      = .false. !  Logical switch for Direct Initialization (DI)
+    ln_asmiau      = .false. !  Logical switch for Incremental Analysis Updating (IAU)
+    ln_seaiceinc   = .false. !  Logical switch for applying sea ice increments
+    ln_phytobal    = .false. !  Logical switch for phytoplankton multivariate balancing
+    ln_slchltotinc = .false. !  Logical switch for applying slchltot increments
+    ln_slchldiainc = .false. !  Logical switch for applying slchldia increments
+    ln_slchlnoninc = .false. !  Logical switch for applying slchlnon increments
+    ln_schltotinc  = .false. !  Logical switch for applying schltot increments
+    ln_slphytotinc = .false. !  Logical switch for applying slphytot increments
+    ln_slphydiainc = .false. !  Logical switch for applying slphydia increments
+    ln_slphynoninc = .false. !  Logical switch for applying slphynon increments
+    ln_sfco2inc    = .false. !  Logical switch for applying sfCO2 increments
+    ln_spco2inc    = .false. !  Logical switch for applying spCO2 increments
+    ln_plchltotinc = .false. !  Logical switch for applying plchltot increments
+    ln_pchltotinc  = .false. !  Logical switch for applying pchltot increments
+    ln_pno3inc     = .false. !  Logical switch for applying pno3 increments
+    ln_psi4inc     = .false. !  Logical switch for applying psi4 increments
+    ln_pdicinc     = .false. !  Logical switch for applying pdic increments
+    ln_palkinc     = .false. !  Logical switch for applying palk increments
+    ln_pphinc      = .false. !  Logical switch for applying pph increments
+    ln_po2inc      = .false. !  Logical switch for applying po2 increments
     ln_temnofreeze = .false. !  Logical to not add increments if temperature would fall below freezing
-    nitbkg    = 0          !  Timestep of background in [0,nitend-nit000-1]
-    nitdin    = 0          !  Timestep of background for DI in [0,nitend-nit000-1]
-    nitiaustr = 1          !  Timestep of start of IAU interval in [0,nitend-nit000-1]
-    nitiaufin = 15         !  Timestep of end of IAU interval in [0,nitend-nit000-1]
-    niaufn    = 0          !  Type of IAU weighting function
-    ln_salfix = .false.    !  Logical switch for ensuring that the sa > salfixmin
-    salfixmin = -9999      !  Minimum salinity after applying the increments
-    nn_divdmp = 0          !  Number of iterations of divergence damping operator
+    nitbkg         = 0       !  Timestep of background in [0,nitend-nit000-1]
+    nitdin         = 0       !  Timestep of background for DI in [0,nitend-nit000-1]
+    nitiaustr      = 1       !  Timestep of start of IAU interval in [0,nitend-nit000-1]
+    nitiaufin      = 15      !  Timestep of end of IAU interval in [0,nitend-nit000-1]
+    niaufn         = 0       !  Type of IAU weighting function
+    ln_salfix      = .false. !  Logical switch for ensuring that the sa > salfixmin
+    salfixmin      = -9999   !  Minimum salinity after applying the increments
+    nn_divdmp      = 0       !  Number of iterations of divergence damping operator
+    mld_choice_bgc = 1       !  MLD criterion to use for biogeochemistry assimilation
+    rn_maxchlinc   = -999.0  !  maximum absolute non-log chlorophyll increment from ocean colour assimilation
+                             !  <= 0 implies no maximum applied (switch turned off)
+                             !   > 0 implies maximum absolute chl increment capped at this value
 /
 !-----------------------------------------------------------------------
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90	(revision 10149)
@@ -49,4 +49,7 @@
 #if defined key_lim3
    USE ice
+#endif
+#if defined key_top
+   USE asmbgc, ONLY: asm_bgc_bkg_wri
 #endif
    USE timing
@@ -125,4 +128,8 @@
             IF(nn_timing == 2)  CALL timing_stop('iom_rstput')
             !
+#if defined key_top
+            CALL asm_bgc_bkg_wri( kt, inum )
+            !
+#endif
             CALL iom_close( inum )
          ENDIF
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 10149)
@@ -44,4 +44,5 @@
 #endif
    USE sbc_oce          ! Surface boundary condition variables.
+   USE asmbgc           ! Biogeochemistry assimilation
 
    IMPLICIT NONE
@@ -54,4 +55,5 @@
    PUBLIC   ssh_asm_inc    !: Apply the SSH increment
    PUBLIC   seaice_asm_inc !: Apply the seaice increment
+   PUBLIC   bgc_asm_inc    !: Apply the biogeochemistry increments
 
 #if defined key_asminc
@@ -67,4 +69,5 @@
    LOGICAL, PUBLIC :: ln_sshinc = .FALSE.      !: No sea surface height assimilation increment
    LOGICAL, PUBLIC :: ln_seaiceinc             !: No sea ice concentration increment
+   LOGICAL, PUBLIC :: lk_bgcinc = .FALSE.      !: No biogeochemistry increments
    LOGICAL, PUBLIC :: ln_salfix = .FALSE.      !: Apply minimum salinity check
    LOGICAL, PUBLIC :: ln_temnofreeze = .FALSE. !: Don't allow the temperature to drop below freezing
@@ -133,10 +136,17 @@
       REAL(wp), POINTER, DIMENSION(:,:) ::   hdiv   ! 2D workspace
       !!
-      NAMELIST/nam_asminc/ ln_bkgwri,                                      &
+      NAMELIST/nam_asminc/ ln_bkgwri, ln_balwri,                           &
          &                 ln_trainc, ln_dyninc, ln_sshinc,                &
+         &                 ln_phytobal, ln_slchltotinc, ln_slchldiainc,    &
+         &                 ln_slchlnoninc, ln_schltotinc, ln_slphytotinc,  &
+         &                 ln_slphydiainc, ln_slphynoninc, ln_spco2inc,    &
+         &                 ln_sfco2inc, ln_plchltotinc, ln_pchltotinc,     &
+         &                 ln_pno3inc, ln_psi4inc, ln_pdicinc, ln_palkinc, &
+         &                 ln_pphinc, ln_po2inc,                           &
          &                 ln_asmdin, ln_asmiau,                           &
          &                 nitbkg, nitdin, nitiaustr, nitiaufin, niaufn,   &
          &                 ln_salfix, salfixmin, nn_divdmp,                &
-         &                 ln_seaiceinc, ln_temnofreeze
+         &                 ln_seaiceinc, ln_temnofreeze,                   &
+         &                 mld_choice_bgc, rn_maxchlinc
       !!----------------------------------------------------------------------
 
@@ -161,6 +171,7 @@
          WRITE(numout,*) 'asm_inc_init : Assimilation increment initialization :'
          WRITE(numout,*) '~~~~~~~~~~~~'
-         WRITE(numout,*) '   Namelist namasm : set assimilation increment parameters'
+         WRITE(numout,*) '   Namelist nam_asminc : set assimilation increment parameters'
          WRITE(numout,*) '      Logical switch for writing out background state          ln_bkgwri = ', ln_bkgwri
+         WRITE(numout,*) '      Logical switch for writing out balancing increments      ln_balwri = ', ln_balwri
          WRITE(numout,*) '      Logical switch for applying tracer increments            ln_trainc = ', ln_trainc
          WRITE(numout,*) '      Logical switch for applying velocity increments          ln_dyninc = ', ln_dyninc
@@ -168,4 +179,22 @@
          WRITE(numout,*) '      Logical switch for Direct Initialization (DI)            ln_asmdin = ', ln_asmdin
          WRITE(numout,*) '      Logical switch for applying sea ice increments        ln_seaiceinc = ', ln_seaiceinc
+         WRITE(numout,*) '      Logical switch for phytoplankton balancing             ln_phytobal = ', ln_phytobal
+         WRITE(numout,*) '      Logical switch for applying slchltot increments     ln_slchltotinc = ', ln_slchltotinc
+         WRITE(numout,*) '      Logical switch for applying slchldia increments     ln_slchldiainc = ', ln_slchldiainc
+         WRITE(numout,*) '      Logical switch for applying slchlnon increments     ln_slchlnoninc = ', ln_slchlnoninc
+         WRITE(numout,*) '      Logical switch for applying schltot increments       ln_schltotinc = ', ln_schltotinc
+         WRITE(numout,*) '      Logical switch for applying slphytot increments     ln_slphytotinc = ', ln_slphytotinc
+         WRITE(numout,*) '      Logical switch for applying slphydia increments     ln_slphydiainc = ', ln_slphydiainc
+         WRITE(numout,*) '      Logical switch for applying slphynon increments     ln_slphynoninc = ', ln_slphynoninc
+         WRITE(numout,*) '      Logical switch for applying spco2 increments           ln_spco2inc = ', ln_spco2inc
+         WRITE(numout,*) '      Logical switch for applying sfco2 increments           ln_sfco2inc = ', ln_sfco2inc
+         WRITE(numout,*) '      Logical switch for applying plchltot increments     ln_plchltotinc = ', ln_plchltotinc
+         WRITE(numout,*) '      Logical switch for applying pchltot increments       ln_pchltotinc = ', ln_pchltotinc
+         WRITE(numout,*) '      Logical switch for applying pno3 increments             ln_pno3inc = ', ln_pno3inc
+         WRITE(numout,*) '      Logical switch for applying psi4 increments             ln_psi4inc = ', ln_psi4inc
+         WRITE(numout,*) '      Logical switch for applying pdic increments             ln_pdicinc = ', ln_pdicinc
+         WRITE(numout,*) '      Logical switch for applying palk increments             ln_palkinc = ', ln_palkinc
+         WRITE(numout,*) '      Logical switch for applying pph increments               ln_pphinc = ', ln_pphinc
+         WRITE(numout,*) '      Logical switch for applying po2 increments               ln_po2inc = ', ln_po2inc
          WRITE(numout,*) '      Logical switch for Incremental Analysis Updating (IAU)   ln_asmiau = ', ln_asmiau
          WRITE(numout,*) '      Timestep of background in [0,nitend-nit000-1]            nitbkg    = ', nitbkg
@@ -176,4 +205,6 @@
          WRITE(numout,*) '      Logical switch for ensuring that the sa > salfixmin      ln_salfix = ', ln_salfix
          WRITE(numout,*) '      Minimum salinity after applying the increments           salfixmin = ', salfixmin
+         WRITE(numout,*) '      Choice of MLD for BGC assimilation                  mld_choice_bgc = ', mld_choice_bgc
+         WRITE(numout,*) '      Maximum absolute chlorophyll increment (<=0 = off)    rn_maxchlinc = ', rn_maxchlinc
       ENDIF
 
@@ -212,4 +243,13 @@
          WRITE(numout,*) '       iitiaufin_date = ', iitiaufin_date
       ENDIF
+      
+      IF ( ln_slchltotinc .OR. ln_slchldiainc .OR. ln_slchlnoninc .OR. &
+         & ln_schltotinc  .OR. ln_slphytotinc .OR. ln_slphydiainc .OR. &
+         & ln_slphynoninc .OR. ln_spco2inc    .OR. ln_sfco2inc    .OR. &
+         & ln_plchltotinc .OR. ln_pchltotinc  .OR. ln_pno3inc     .OR. &
+         & ln_psi4inc     .OR. ln_pdicinc     .OR. ln_palkinc     .OR. &
+         & ln_pphinc      .OR. ln_po2inc ) THEN
+         lk_bgcinc = .TRUE.
+      ENDIF
 
       IF ( nacc /= 0 ) &
@@ -223,6 +263,8 @@
 
       IF (      ( ( .NOT. ln_asmdin ).AND.( .NOT. ln_asmiau ) ) &
-           .AND.( ( ln_trainc ).OR.( ln_dyninc ).OR.( ln_sshinc ) .OR. ( ln_seaiceinc) )) &
-         & CALL ctl_stop( ' One or more of ln_trainc, ln_dyninc, ln_sshinc and ln_seaiceinc is set to .true.', &
+         & .AND.( ( ln_trainc ).OR.( ln_dyninc ).OR.( ln_sshinc ).OR.( ln_seaiceinc ).OR. &
+         &        ( lk_bgcinc ) )) &
+         & CALL ctl_stop( ' One or more of ln_trainc, ln_dyninc, ln_sshinc, ln_seaiceinc,', &
+         &                ' ln_(bgc-variable)inc is set to .true.', &
          &                ' but ln_asmdin and ln_asmiau are both set to .false. :', &
          &                ' Inconsistent options')
@@ -233,6 +275,7 @@
 
       IF ( ( .NOT. ln_trainc ).AND.( .NOT. ln_dyninc ).AND.( .NOT. ln_sshinc ).AND.( .NOT. ln_seaiceinc ) &
-         &                     )  &
-         & CALL ctl_warn( ' ln_trainc, ln_dyninc, ln_sshinc and ln_seaiceinc are set to .false. :', &
+         & .AND.( .NOT. lk_bgcinc ) )  &
+         & CALL ctl_warn( ' ln_trainc, ln_dyninc, ln_sshinc, ln_seaiceinc,', &
+         &                ' ln_(bgc-variable)inc are set to .false. :', &
          &                ' The assimilation increments are not applied')
 
@@ -254,4 +297,6 @@
          &                ' Background time step for Direct Initialization is outside', &
          &                ' the cycle interval')
+      
+      IF ( lk_bgcinc ) CALL asm_bgc_check_options
 
       IF ( nstop > 0 ) RETURN       ! if there are any errors then go no further
@@ -350,5 +395,6 @@
       ssh_iau(:,:)    = 0.0
 #endif
-      IF ( ( ln_trainc ).OR.( ln_dyninc ).OR.( ln_sshinc ).OR.( ln_seaiceinc ) ) THEN
+      IF ( ( ln_trainc ).OR.( ln_dyninc ).OR.( ln_sshinc ).OR.( ln_seaiceinc ) &
+         &  .OR.( lk_bgcinc ) ) THEN
 
          !--------------------------------------------------------------------
@@ -424,4 +470,8 @@
          ENDIF
 
+         IF ( lk_bgcinc ) THEN
+            CALL asm_bgc_init_incs( inum )
+         ENDIF
+
          CALL iom_close( inum )
  
@@ -534,4 +584,8 @@
          CALL iom_close( inum )
 
+      ENDIF
+         
+      IF ( lk_bgcinc ) THEN
+         CALL asm_bgc_init_bkg
       ENDIF
       !
@@ -1155,4 +1209,57 @@
 
    END SUBROUTINE seaice_asm_inc
+
+
+   SUBROUTINE bgc_asm_inc( kt )
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE bgc_asm_inc  ***
+      !!          
+      !! ** Purpose : Apply the biogeochemistry assimilation increments
+      !!
+      !! ** Method  : Call relevant routines in asmbgc
+      !!
+      !! ** Action  : Call relevant routines in asmbgc
+      !!
+      !!----------------------------------------------------------------------
+      !!
+      INTEGER, INTENT(in   ) :: kt        ! Current time step
+      !
+      INTEGER                :: icycper   ! Dimension of wgtiau
+      !!
+      !!----------------------------------------------------------------------
+      
+      icycper = SIZE( wgtiau )
+      
+      ! Ocean colour variables first
+      IF ( ln_slchltotinc .OR. ln_slchldiainc .OR. ln_slchlnoninc .OR. &
+         & ln_schltotinc  .OR. ln_slphytotinc .OR. ln_slphydiainc .OR. &
+         & ln_slphynoninc ) THEN
+         CALL phyto2d_asm_inc( kt, ln_asmdin, ln_asmiau, icycper, wgtiau )
+      ENDIF
+      
+      ! Surface pCO2/fCO2 next
+      IF ( ln_sfco2inc .OR. ln_spco2inc ) THEN
+         CALL pco2_asm_inc( kt, ln_asmdin, ln_asmiau, icycper, wgtiau, &
+            &               ln_trainc, t_bkginc, s_bkginc )
+      ENDIF
+      
+      ! Profile pH next
+      IF ( ln_pphinc ) THEN
+         CALL ph_asm_inc( kt, ln_asmdin, ln_asmiau, icycper, wgtiau, &
+            &             ln_trainc, t_bkginc, s_bkginc )
+      ENDIF
+      
+      ! Then chlorophyll profiles
+      IF ( ln_plchltotinc .OR. ln_pchltotinc ) THEN
+         CALL phyto3d_asm_inc( kt, ln_asmdin, ln_asmiau, icycper, wgtiau )
+      ENDIF
+      
+      ! Remaining bgc profile variables
+      IF ( ln_pno3inc .OR. ln_psi4inc .OR. ln_pdicinc .OR. &
+         & ln_palkinc .OR. ln_po2inc ) THEN
+         CALL bgc3d_asm_inc( kt, ln_asmdin, ln_asmiau, icycper, wgtiau )
+      ENDIF
+
+   END SUBROUTINE bgc_asm_inc
    
    !!======================================================================
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ASM/asmpar.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ASM/asmpar.F90	(revision 10020)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/NEMO/OPA_SRC/ASM/asmpar.F90	(revision 10149)
@@ -20,7 +20,10 @@
       & c_asmtrj = 'assim_trj',                  & !: Filename for storing the 
                                                    !: reference trajectory
-      & c_asminc = 'assim_background_increments'   !: Filename for storing the 
+      & c_asminc = 'assim_background_increments', & !: Filename for storing the 
                                                    !: increments to the background
                                                    !: state
+      & c_asmbal = 'assim.balincs'                 !: Filename for storing the 
+                                                   !: balancing increments calculated
+                                                   !: for biogeochemistry
 
    INTEGER, PUBLIC :: nitbkg_r      !: Background time step referenced to nit000
